#!/usr/bin/env python

from os.path import abspath, join, split
import sys

dirname = split(abspath(sys.argv[0]))[0]
parent = split(dirname)[0]

try:
    import moinformat
except ImportError:
    if split(parent)[1] == "MoinLight":
        sys.path.append(parent)

from moinformat import parse, parsers, serialise, serialisers
from glob import glob

def test_input(s):
    d = parse(s, parsers)
    o = serialise(d)

    identical = o == s

    if quiet:
        return identical

    # Show output versus input comparison result.

    print identical
    print "-" * 60
    print o
    if o != s:
        print "-" * 60
        print s
    print "-" * 60
    print serialise(d, serialisers["html"])
    print "-" * 60
    print d.prettyprint()
    print

    return identical

if __name__ == "__main__":
    args = sys.argv[1:]
    quiet = "-q" in args
    if quiet:
        del args[args.index("-q")]
    filenames = args or glob(join(dirname, "test*.txt"))
    filenames.sort()

    for filename in filenames:
        f = open(filename)
        try:
            if not quiet:
                print filename
            identical = test_input(f.read())
            if quiet:
                print "%s: %s" % (identical, filename)
        finally:
            f.close()

# vim: tabstop=4 expandtab shiftwidth=4
